﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.UI.WebControls;

public partial class _Default : System.Web.UI.Page
{
protected void Page_Load(object sender, EventArgs e)
{
    TestEntities entities = new TestEntities();
    int mId = 1;
    var list2 = new List<Task>();
    list2.Add(new Task { OperationID = 1, MachineID = 1, Id = 1 });
    list2.Add(new Task { OperationID = 3, MachineID = 1, Id = 3 });
    list2.Add(new Task { OperationID = 5, MachineID = 1, Id = 4 });

    var list1 = entities.DownloadTasks.Where(x => x.MachineId == mId).ToList();

    foreach (Task task in list2)
    {
        var exists = list1.Where(x => x.OperationId == task.OperationID).FirstOrDefault();
        if (exists == null)
        {
            DownloadTask dtask = new DownloadTask();
            dtask.Id = task.Id;
            dtask.MachineId = task.MachineID;
            dtask.OperationId = task.OperationID;
            entities.DownloadTasks.Add(dtask);
            entities.SaveChanges();
        }
    }

    var updatedlist1 = entities.DownloadTasks.Where(x => x.MachineId == mId).ToList();
    foreach (DownloadTask task in updatedlist1)
    {
        var exists = list2.Where(x => x.OperationID == task.OperationId).FirstOrDefault();
        if (exists == null)
        {
            entities.DownloadTasks.Remove(task);
            entities.SaveChanges();
        }
    }

}

public class Task
{
    public int MachineID { get; set; }
    public int OperationID { get; set; }
    public int Id { get; set; }
}
}